Outline of the slide deck.

### Introduction
* SLIDE: Title
	* We Got This (Moving 800 Drupal 5 sites to Drupal 7)
* SLIDE: Hashtag for twitter
	* UofCDrupalCon
	* Introduce our team both on the AD side and on the Client Services side and why their distinct
	* Give people a chance to switch sessions
	* Describe quickly what the session will cover

### Getting Started
* SLIDE: Statistics
	* 800+ sites
	* 60,000 visitors a day in Spring and Summer semesters
	* 150,000 visitors a day in Fall and Winter semesters
	* Drupal 5
* SLIDE: Drupal 5 no longer cuts it
* SLIDE: Wanted to go to Drupal 7
	* Same great platform
	* No sense stopping on 6 when Drupal 7 is mature, we made that mistake when we went to 5
	* Drupal 5 reached its end of life

### Challenges
* SLIDE: 800 sites
	* Think about that number again
	* To complete the migration within a year, that's around 3 to 4 sites migrated per day
	* Any migration guide we found described the process as no problem, just run upgrade scripts and manually add missing content or fix broken content
	* Significant manual intervention isn't an option for us
* SLIDE: 800 site admins
	* Well, not quite, as many site admins are responsible for an entire department or faculty's sites
	* But you can imagine the complexity, each site admin has varying degrees of skill
	* We control the look, feel and modules supplied to site admins, but they still have freedom to do a lot of different things
	* Page layouts assembled with nested table after nested table, or the worst, message forum with anonymous access to posting
* SLIDE: 4 years of cruft
	* Our Drupal 5 environment has been around for 4 years
	* Guilty of slapping on modules to give users functionality without proper review
	* Our client services team helps clients build sites through the UI, discovered their prevalent use of Contemplate over hundreds of sites
* SLIDE: Custom modules and theme
	* We have a theme and a suite of custom modules for use on our sites that needed to be updated
* SLIDE: Take-aways
	- For larger migrations, automate as much as you possibly can
	- Deny users the ability to have add modules to their sites, have a module/feature review process instead
	- Contemplate, custom CSS editing and similar tools to give users theming over their sites are a bad idea, do things the right way in the theme with TPL files, provide consistent styling to your users

### Building a Project
* SLIDE: Two projects
	* Migrating Drupal 5 sites to Drupal 7
	* Creating a new Drupal 7 environment
* SLIDE: Creating a new Drupal 7 environment
	* Update theme and modules for Drupal 7
	* Choose a template site configuration
	* Largely replicating the configuration of our Drupal 5 sites as best we can in Drupal 7 for ease of migration
	* This needs to be far along enough before migration can happen
	* Provides a quick-win, new sites requested from clients can be launched on Drupal 7
* SLIDE: Migrating Drupal 5 sites to Drupal 7
	* Need to craft scripts to automate the migration as much as possible
	* Need to make sure end state of migrated Drupal 5 site matches Drupal 7 template site as much as possible
	* This means doing the nitty-gritty work of ensuring content types, field names, etc. match Drupal 7 template site counterparts
* SLIDE: Doing our homework
	* Dug up how many modules are used by how many sites to determine what matters and what really doesn't
* SLIDE: Take-aways
	- Quick wins matter, being able to see your work in production ensures you'll reach the finish line
	- Assess what you have, know what modules you use and where you use them so there are no show-stoppers
	- Do your homework, know exactly what features you want your Drupal sites to have, and how you'll achieve that
	- Make a plan

### Running the Project
* SLIDE: Running the project
	* We've wrapped our head around a giant migration and what's needed
	* Used Microsoft Project to keep everyone on task
	* Gives a good visual of all the tasks involved in this mighty move and how these tasks interact
* SLIDE: Developer tools
	* We used SVN and Trac, but you can use Git and GitHub if you're not stuck in the past
	* Created a Drupal 7 branch, we still need to be able to work on Drupal 5 versions as they continue to be live
	* Important to create milestones for each custom module developed so you can see what work is left to get a working Drupal 7.x 1.0 version
* SLIDE: Overview of the project
	* Division of labour
	* Client services and development team can work independently
	* Client services helps craft the requirements and the template site
	* Client services develops training for our campus clients
	* If you want more information on that they will be running a session
	* Us in Applications Development do the technical heavy-lifting
* SLIDE: Take-aways
	- Write down every task
	- Maintain a project plan to keep everyone aware of their work within a giant migration
	- Use GitHub, Trac or an equivalent to manage developer progress

### Managing the Environment
* SLIDE: Our Drupal 5 environment
	* 2 web servers with shared network drive
	* 1 load balanced name in front of the webservers
	* 1 db server
* SLIDE: Our Drupal 7 environment
	* 2 web servers with shared network drive
	* 1 db server
	* 1 load balanced name in front of the webservers
	* Why mess with what has been a good formula
	* We've added this environment, not replaced the D5 environment with this, as migration of all 800+ sites can't happen in a flip of a switch
* SLIDE: Mixing the two
	* All our requests to ucalgary.ca or other domain names we control go to two load-balanced web servers
	* These servers proxy onto our Drupal 5 environment if it's a Drupal site
	* Bringing Drupal 7 sites into the fold is easy, we simply proxy over to the Drupal 7 environment instead for any given site that is now Drupal 7
* SLIDE: One more machine…
	* We need one more server, the migration machine
	* Runs Drupal 5, Drupal 6 and Drupal 7
	* Uses PHP 5.2 as its the only version of PHP that works on with all 3 Drupal versions
	* MySQL locally installed
	* This machine has access to production Drupal 5 web server and database server to pull sites
	* This machine has access to production Drupal 7 web server and database server to push sites
	* This box is where the migration magic happens, scripts will upgrade a site from 5 to 6 to 7
	* Can be used to view the site in Drupal 6 and it's final state in Drupal 7 to see where the failure happened
	* Databases can be viewed, prefixed with drupalX_ where X is the number of the Drupal version
* SLIDE: File architecture
	* Breakdown of our multi-site installation and its folders
	* Breakdown of Drupal versions sitting side-by-side and their folders
* SLIDE: Take-aways
	- Running production environments side-by-side ensures no down-time, easy back-out and visible progress
	- Create a migration server and a work flow, pulling from D5 production, reviewing, and pushing to D7 production keeps things as fast as they can be
	- Setup your databases, file system to allow side-by-side environments on the migration server

### Scripting, Scripting, Scripting!
* SLIDE: Drush
	* Command line tool to work with sites without using the UI
	* Not an option - absolutely essential for migration or provisioning of a Drupal multi-site environment
* SLIDE: Going farther
	* Drush does not do enough out of the box
	* It has all the basics, upgrade command, module management, Drupal bootstrapping (so we don't need to manually connect to the database)
	* But we have to extend it to do what we're doing
	* We've extended it through bash scripts and PHP Drush functions
	* I wouldn't recommend bash, we were trying to make things light weight in calling other scripts and Drush, but the time that saved us was lost in dealing with the "intricacies" of bash, use PHP all the way through or Python
* SLIDE: Defining the environment
	* We defined as much as we could about our environment in variables so directories can be changed in one location
	* This is because the environment evolved as we worked
	* Also allows for rapid development our developers to have their own branch of the migration scripts so they can work on specific steps individually
* SLIDE: The steps
	* We'll give a brief overview of all the steps in our migration process
	* This represents a lot of trial and error
	* There is no science to this, your results may vary
	* It started from the guidelines at Drupal.org: http://drupal.org/node/570162
* SLIDE: Drupal 5 to 6 steps
* SLIDE: Drupal 6 to 7 steps
* SLIDE: Schema manipulation
	* Many of the steps require manual schema intervention
	* Get familiar with the database schema
	* Some example steps we did of schema manipulation
* SLIDE: Take-aways
	* Drush, know it, use it, love it
	* Don't be lazy with bash scripts, invest a little more time in a stronger suite of scripts, you'll be using them a lot of if you're moving an institutions worth of sites
	* Make the scripts environment agnostic
	
### Pain points
* SLIDE: Simple sites are easy
	* It didn't take too much work to get simple sites moved from D5 to D7
	* Simple meaning not many contributed modules
	* Unfortunately the most important and visited UofC sites are also the most complex
* SLIDE: Contemplate
* SLIDE: CCK
* SLIDE: Private files
* SLIDE: Views

### Wrap up
* SLIDE: Where we were
	* Stuck on Drupal 5
	* I was here at DrupalCon Denver going to every migration related session I could
	* Got tired of hearing people's jaws drop when I told them the size and scale of this migration
	* Began this project in September last year
* SLIDE: Where we are at
	* Production Drupal 7 environment rolled out in December
	* Launched with new sites immediately
	* Finished a pilot migration in January to see how well our process worked
	* Process was good, scripts needed work
	* Migrated our first sites in February
	* We've migrated X sites as of today
* SLIDE: Questions?